Name:           courier-authlib
Version:        0.70.0
Release:        %mkrel 1
Summary:        Courier authentication library
Group:          System/Servers
License:        GPLv3
URL:            http://www.courier-mta.org
Source0:        http://prdownloads.sourceforge.net/courier/%{name}-%{version}.tar.bz2
Source1:        courier-authlib.sysconftool.m4
Source2:        courier-authlib.authdaemon-init
Patch0:         courier-authlib-0.58.sysconftool.patch
BuildRequires:  expect
BuildRequires:  libltdl-devel
BuildRequires:  gdbm-devel
BuildRequires:  openldap-devel
BuildRequires:  pam-devel
BuildRequires:  mysql-devel
BuildRequires:  postgresql-devel
BuildRequires:  pkgconfig(sqlite3)
BuildRequires:  courier-unicode-devel
Obsoletes:      courier-imap-utils < %{version}%{release}
Obsoletes:      libcourier-authlib0 < %{version}%{release}
Conflicts:      courier-imap <= 3.0.8
# because %%{_sysconfdir}/ld.so.conf.d/courier-authlib.conf and *.so files
# were moved from courier-authlib-devel (fixes #7727)
Conflicts:	courier-authlib-devel < 0.65.0-2

%description
The Courier authentication library provides authentication
services for other Courier applications.

This package contains the Courier authentication daemon and common
authentication modules:

 o authcustom
 o authpam
 o authpwd
 o authshadow
 o courierauthsaslclient
 o courierauthsasl

%package -n courier-authdaemon
Summary:        Courier authentication daemon
Group:          System/Servers
Requires:       %{name} = %{version}
Requires:       expect
Requires(post): systemd >= %{systemd_required_version}
Requires(pre):  rpm-helper

%description -n courier-authdaemon
This package contains the Courier authentication daemon.

%package userdb
Summary:        Userdb support for the Courier authentication library
Group:          System/Servers
Requires(pre):  %{name} = %{version}

%description userdb
This package installs the userdb support for the Courier
authentication library.  Userdb is a simple way to manage virtual
mail accounts using a GDBM-based database file.

Install this package in order to be able to authenticate with
userdb.

%package ldap
Summary:        LDAP support for the Courier authentication library
Group:          System/Servers
Requires(pre):  %{name} = %{version}
Obsoletes:      courier-imap-ldap < %{version}%{release}

%description ldap
This package installs LDAP support for the Courier authentication
library. Install this package in order to be able to authenticate
using LDAP.

%package mysql
Summary:        MySQL support for the Courier authentication library
Group:          System/Servers
Requires(pre):  %{name} = %{version}
Obsoletes:      courier-imap-mysql < %{version}%{release}

%description mysql
This package installs MySQL support for the Courier authentication
library. Install this package in order to be able to authenticate
using MySQL.

%package pgsql
Summary:        MySQL support for the Courier authentication library
Group:          System/Servers
Requires(pre):  %{name} = %{version}
Obsoletes:      courier-imap-pgsql < %{version}%{release}

%description pgsql
This package installs PostgreSQL support for the Courier
authentication library. Install this package in order to be able
to authenticate using PostgreSQL.

%package sqlite
Summary:        SQLite support for the Courier authentication library
Group:          System/Servers
Requires(pre):  %{name} = %{version}

%description sqlite
This package installs sqlite support for the Courier
authentication library. Install this package in order to be able to
authenticate using SQLite.

%package devel
Summary:        Development libraries for the Courier authentication library
Group:          Development/C
Requires:       %{name} = %{version}

%description devel
This package contains the development libraries and files needed
to compile Courier packages that use this authentication library.
Install this package in order to build the rest of the Courier
packages. After they are built and installed this package can be
removed. Files in this package are not needed at runtime.

%prep
%setup -q
%patch0 -p 0 -b .sysconftool

install -Dpm644 %{SOURCE1} sysconftool.m4

%build
autoreconf -vfi -I.
%configure \
    --disable-static \
    --with-syslog=MAIL \
    --disable-ltdl-install \
    --with-db=gdbm \
    --with-random=/dev/urandom \
    --with-mailuser=daemon \
    --with-mailgroup=daemon \
    --with-authdaemonrc=%{_sysconfdir}/courier/authdaemonrc \
    --with-authdaemonvar=%{_localstatedir}/lib/authdaemon \
    --with-makedatprog=%{_sbindir}/makedatprog \
    --with-userdb=%{_sysconfdir}/userdb \
    --with-pkgconfdir=%{_sysconfdir}/courier \
    --with-authuserdb \
    --with-authpam \
    --with-authldap \
    --with-authldaprc=%{_sysconfdir}/courier/authldaprc \
    --with-authpwd \
    --with-authshadow \
    --without-authvchkpw \
    --with-authpgsqlrc=%{_sysconfdir}/courier/authpgsqlrc \
    --with-authpgsql \
    --with-pgsql-libs=%{_libdir} \
    --with-pgsql-includes=%{_includedir}/pgsql \
    --with-authmysqlrc=%{_sysconfdir}/courier/authmysqlrc \
    --with-authmysql \
    --with-mysql-libs=%{_libdir} \
    --with-mysql-includes=%{_includedir}/mysql \
    --with-authcustom
%make_build
#make_build authinfo

%check
%{__make} check

%install
%make_install

find %{buildroot} -name '*.la' | xargs rm

# fix perms
chmod 755 %{buildroot}%{_localstatedir}/lib/authdaemon

install -m 755 sysconftool %{buildroot}%{_libdir}/courier-authlib/
install -m 755 authmigrate %{buildroot}%{_libdir}/courier-authlib/

install -d -m 755 %{buildroot}%{_initrddir}
install -m 755 %{SOURCE2} %{buildroot}%{_initrddir}/courier-authdaemon
mv %{buildroot}%{_libexecdir}/courier-authlib/authdaemond %{buildroot}%{_sbindir}/authdaemond

mv %{buildroot}%{_libexecdir}/courier-authlib/makedatprog %{buildroot}%{_sbindir}/makedatprog

# some utils...
# install -m 755 authinfo %%{buildroot}%%{_sbindir}/
install -m 755 authdaemontest %{buildroot}%{_sbindir}/
#install -m 755 liblock/lockmail %{buildroot}%{_sbindir}/
#install -m 644 liblock/lockmail.1 %{buildroot}%{_mandir}/man1/

# fix configuration
for file in %{buildroot}%{_sysconfdir}/courier/*.dist; do
    mv $file  %{buildroot}%{_sysconfdir}/courier/`basename $file .dist`
done
chmod 644 %{buildroot}%{_sysconfdir}/courier/*

perl -pi \
    -e "s|^authmodulelist=.*|authmodulelist=\"authpam authpwd authshadow\"|g;" \
    -e "s|^authmodulelistorig=.*|authmodulelistorig=\"authpam authpwd authshadow\"|g;" \
    %{buildroot}%{_sysconfdir}/courier/authdaemonrc

cat > README.mga << EOF
Mageia RPM specific notes

Upgrade
------
Default upgrade procedure consists of shipping new configuration files with
.dist suffix, then running sysconftool script to merge with current
configuration. This packages ships new configuration files with their final
name instead, wich will be saved by rpm as .rpmnew if original ones have been
modified, and run sysconftools script during upgrade automatically.
EOF

# Fix path to libs
cat > courier-authlib.conf << EOF
%{_libdir}/courier-authlib
EOF
install -d %{buildroot}%{_sysconfdir}/ld.so.conf.d
install -m 755 courier-authlib.conf %{buildroot}%{_sysconfdir}/ld.so.conf.d

mkdir -p %{buildroot}%{_tmpfilesdir}
cat <<EOF > %{buildroot}%{_tmpfilesdir}/%{name}.conf
d /run/authdaemon 0755 root root
EOF

%post -n courier-authdaemon
%{_libdir}/courier-authlib/authmigrate >/dev/null
if [ -f %{_sysconfdir}/courier/authdaemonrc.rpmnew ]; then
    %{_libdir}/courier-authlib/sysconftool %{_sysconfdir}/courier/authdaemonrc.rpmnew >/dev/null
fi
%_tmpfilescreate %{name}
%_post_service courier-authdaemon

%preun -n courier-authdaemon
%_preun_service courier-authdaemon

%post userdb
%{_initrddir}/courier-authdaemon condrestart 1>&2;

%postun userdb
if [ "$1" = "0" ]; then
    %{_initrddir}/courier-authdaemon condrestart 1>&2;
fi

%post ldap
%{_libdir}/courier-authlib/authmigrate >/dev/null
if [ -f %{_sysconfdir}/courier/authldaprc.rpmnew ]; then
    %{_libdir}/courier-authlib/sysconftool %{_sysconfdir}/courier/authldaprc.rpmnew >/dev/null
fi
%{_initrddir}/courier-authdaemon condrestart 1>&2;

%postun ldap
if [ "$1" = "0" ]; then
    %{_initrddir}/courier-authdaemon condrestart 1>&2;
fi

%post mysql
%{_libdir}/courier-authlib/authmigrate >/dev/null
if [ -f %{_sysconfdir}/courier/authmysqlrc.rpmnew ]; then
    %{_libdir}/courier-authlib/sysconftool %{_sysconfdir}/courier/authmysqlrc.rpmnew >/dev/null
fi
%{_initrddir}/courier-authdaemon condrestart 1>&2;

%postun mysql
if [ "$1" = "0" ]; then
    %{_initrddir}/courier-authdaemon condrestart 1>&2;
fi

%pre pgsql
%{_libdir}/courier-authlib/authmigrate >/dev/null

%post pgsql
%{_initrddir}/courier-authdaemon condrestart 1>&2;

%postun pgsql
if [ "$1" = "0" ]; then
    %{_initrddir}/courier-authdaemon condrestart 1>&2;
fi

%files
%doc README.mga README README.authdebug.html README.html README_authlib.html
%doc NEWS COPYING* AUTHORS ChangeLog
#doc liblock/lockmail.html liblog/courierlogger.html
%dir %{_sysconfdir}/courier
%dir %{_libdir}/courier-authlib
%{_sysconfdir}/ld.so.conf.d/courier-authlib.conf
%{_libdir}/courier-authlib/authmigrate
%{_libexecdir}/courier-authlib/authsystem.passwd
%{_libdir}/courier-authlib/sysconftool
%{_libdir}/courier-authlib/libcourierauthsaslclient.so*
%{_libdir}/courier-authlib/libcourierauthsasl.so*
%{_libdir}/courier-authlib/libcourierauthcommon.so*
%{_libdir}/courier-authlib/libcourierauth.so*
%{_libdir}/courier-authlib/libauthcustom.so*
%{_libdir}/courier-authlib/libauthpam.so*
%{_libdir}/courier-authlib/libauthpwd.so*
%{_libdir}/courier-authlib/libauthshadow.so*
%{_libdir}/courier-authlib/libauthpipe.so*
%{_mandir}/man1/*

%files -n courier-authdaemon
%config(noreplace) %{_sysconfdir}/courier/authdaemonrc
%{_tmpfilesdir}/%{name}.conf
%{_sbindir}/authdaemond
%{_sbindir}/authdaemontest
%{_sbindir}/authenumerate
# %%{_sbindir}/authinfo
%{_sbindir}/authtest
%{_sbindir}/courierlogger
#{_sbindir}/lockmail
%{_sbindir}/authpasswd
%{_sbindir}/makedatprog
%{_initrddir}/courier-authdaemon
%{_localstatedir}/lib/authdaemon

%files userdb
%doc userdb/makeuserdb.html userdb/userdb.html userdb/userdbpw.html
%{_sbindir}/makeuserdb
%{_sbindir}/pw2userdb
%{_sbindir}/userdb
%{_sbindir}/userdb-test-cram-md5
%{_sbindir}/userdbpw
%{_libdir}/courier-authlib/libauthuserdb.so*
%{_mandir}/man8/*userdb*

%files ldap
%doc README.ldap authldap.schema
%config(noreplace) %{_sysconfdir}/courier/authldaprc
%{_libdir}/courier-authlib/libauthldap.so*

%files mysql
%doc README.authmysql.html README.authmysql.myownquery
%config(noreplace) %{_sysconfdir}/courier/authmysqlrc
%{_libdir}/courier-authlib/libauthmysql.so*

%files pgsql
%doc README.authpostgres.html
%config(noreplace) %{_sysconfdir}/courier/authpgsqlrc
%{_libdir}/courier-authlib/libauthpgsql.so*

%files sqlite
%doc README.authsqlite.html
%config(noreplace) %{_sysconfdir}/courier/authsqliterc
%{_libdir}/courier-authlib/libauthsqlite.so*

%files devel
%doc authlib.html auth_*.html
%{_bindir}/courierauthconfig
%{_includedir}/*
%{_mandir}/man3/*


%changelog
* Wed Jun 03 2020 cheeseeboi <cheeseeboi> 0.70.0-1.mga8
+ Revision: 1590065
- updated to version 0.70.0

* Fri Feb 14 2020 umeabot <umeabot> 0.69.0-2.mga8
+ Revision: 1520455
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Thu Nov 22 2018 shlomif <shlomif> 0.69.0-1.mga7
+ Revision: 1333249
- New version 0.69.0

* Sun Sep 23 2018 umeabot <umeabot> 0.68.0-3.mga7
+ Revision: 1296841
- Mageia 7 Mass Rebuild

* Sun Jun 17 2018 luigiwalser <luigiwalser> 0.68.0-2.mga7
+ Revision: 1237480
- rebuild for gdbm

* Sat Dec 23 2017 wally <wally> 0.68.0-1.mga7
+ Revision: 1184370
- new version 0.68.0
- rebuild for new mariadb

* Sun Feb 28 2016 oden <oden> 0.66.4-3.mga6
+ Revision: 980335
- rebuilt for postgresql 9.5.x

* Mon Feb 08 2016 umeabot <umeabot> 0.66.4-2.mga6
+ Revision: 950861
- Mageia 6 Mass Rebuild

* Sat Feb 06 2016 wally <wally> 0.66.4-1.mga6
+ Revision: 942171
- new version 0.66.4
- add patch to fix linking

* Tue Nov 25 2014 cjw <cjw> 0.65.0-12.mga5
+ Revision: 799053
- rebuild against postgresql9.4

* Wed Oct 15 2014 umeabot <umeabot> 0.65.0-11.mga5
+ Revision: 743717
- Second Mageia 5 Mass Rebuild

* Fri Sep 26 2014 tv <tv> 0.65.0-10.mga5
+ Revision: 725008
- rebuild for bogus file deps

* Thu Sep 18 2014 umeabot <umeabot> 0.65.0-9.mga5
+ Revision: 693690
- Rebuild to fix library dependencies

* Tue Sep 16 2014 umeabot <umeabot> 0.65.0-8.mga5
+ Revision: 678558
- Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 0.65.0-7.mga4
+ Revision: 522621
- Mageia 4 Mass Rebuild

* Sun Mar 24 2013 colin <colin> 0.65.0-6.mga3
+ Revision: 404859
- Add systemd requires and general post/pre fixes (mga#9302)

* Sun Jan 13 2013 luigiwalser <luigiwalser> 0.65.0-5.mga3
+ Revision: 380025
- add tmpfiles config for /run/authdaemon

* Fri Jan 11 2013 umeabot <umeabot> 0.65.0-4.mga3
+ Revision: 348191
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Jan 01 2013 pterjan <pterjan> 0.65.0-3.mga3
+ Revision: 337446
- Fix for _libdir != _libexecdir

* Thu Oct 11 2012 oden <oden> 0.65.0-2.mga3
+ Revision: 304626
- fix #7727 ( courier-authlib-devel provides)

* Mon Oct 08 2012 barjac <barjac> 0.65.0-1.mga3
+ Revision: 303428
- New version 0.65.0
  Added sqlite sub-package
  Fixed unversioned explicit obsoletes
  Added BuildRequire sqlite3-devel

* Wed Aug 01 2012 sander85 <sander85> 0.64.0-1.mga3
+ Revision: 277335
- New version: 0.64.0

* Tue May 08 2012 pterjan <pterjan> 0.63.0-12.mga2
+ Revision: 234933
- Fix initscript's LSB header
+ guillomovitch <guillomovitch>
- rename distribution-specific documentation file to README.mga

* Tue Dec 06 2011 fwang <fwang> 0.63.0-11.mga2
+ Revision: 177156
- rebuild for new gdbm

* Sat Dec 03 2011 barjac <barjac> 0.63.0-10.mga2
+ Revision: 175716
- Removed ldconfig in %%post & %%postun

* Mon Nov 28 2011 barjac <barjac> 0.63.0-9.mga2
+ Revision: 173752
- Added ldconfig in %%post and %%postun

* Sun Nov 27 2011 shlomif <shlomif> 0.63.0-8.mga2
+ Revision: 173072
- Add lib path to ld.so.conf.d to fix dynamic linking compilation

* Wed Sep 21 2011 fwang <fwang> 0.63.0-7.mga2
+ Revision: 146384
- drop .la files

* Fri Mar 25 2011 dmorgan <dmorgan> 0.63.0-6.mga1
+ Revision: 77243
- Rebuild against new mysql

* Sun Feb 06 2011 spuhler <spuhler> 0.63.0-5.mga1
+ Revision: 47794
- removed buildroot definition from .spec
-Mandriva RPM specific notes
  +Mageia RPM specific notes
- imported package courier-authlib

